#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"

/*
Binh's MOP
f1(x,y)=x**2+y**2
f2(x,y)=(x-5)**2+(y-5)**2
constraints
-5<=x,y,<=10
*/

class Binh:public MicroAG{
public:  
  Binh(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,  double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
};
void Binh::evalua(int *cromosoma,double *aptitud){
  double x=decodifica(0,cromosoma);
  double y=decodifica(1,cromosoma);
  aptitud[0]=(x*x+y*y);
  aptitud[1]=(pow((x-5),2)+pow((y-5),2));
}
void Binh::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    /*
      double x=decodifica(0,ind[i].genotipo);
      double y=decodifica(1,ind[i].genotipo);
      archivo<<x;
      archivo<<"\t";
      archivo<<y;
      archivo<<"\n";
    */
  }
}
void otro(char *archivo){
  char file[20];
  int PARETOsize=100;
  int memSize=50;
  int GMax=1000;
  int M=4;
  int nTope=5;
  int nGenes=2;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.7;
  double Pm=(double)1.0/36.0;
  double *lb=new(double[2]);
  double *ub=new(double[2]);
  int *pres=new(int[2]);
  lb[0]=-5.0;
  lb[1]=-5.0;
  ub[0]=10.0;
  ub[1]=10.0;
  pres[0]=4;
  pres[1]=4;
  int sndelit=50;
  double pNRem=0.3;

  strcpy(file,archivo);

  Binh mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,PARETOsize,memSize,subDivs,base,lb,ub,pres,1,sndelit,pNRem,file);
  mag.Alg();

}
int main(int argc, char **argv)
{
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  otro(argv[1]);
}




