#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"
/*
Funcion de Fonseca
f1(x,y)= 1-exp(-(x-1)**2-(y+1)**2);
f2(x,y)= 1-exp(-(x+1)**2-(y-1)**2);
constraints

*/

class Fonseca:public MicroAG{
public:  
  Fonseca(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
};
void Fonseca::evalua(int *cromosoma,double *aptitud){
  double x=decodifica(0,cromosoma);
  double y=decodifica(1,cromosoma);
  aptitud[0]=1-exp(-pow((x-1),2)-pow((y+1),2));
  aptitud[1]=1-exp(-pow((x+1),2)-pow((y-1),2));
}
void Fonseca::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    /*
    
      double x=decodifica(0,ind[i].genotipo);
      double y=decodifica(1,ind[i].genotipo);
      archivo<<x;
      archivo<<"\t";
      archivo<<y;
      archivo<<"\n";
    */
  }
}
int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
   int tamPARETO=100;
  int tamMem=50;
  int GMax=1000;
  int M=4;
  int nTope=4; 
  int nGenes=2;
  int nObjs=2;
  int base=2;
  int subDivs=20;
  double Pc=0.7;
  double Pm=(double)1.0/34.0;
  double *linf=new(double[2]);//=0.1;
  double *lsup=new(double[2]);//=1;
  int *pres=new(int[2]);//=4;
  linf[0]=-4.0;
  linf[1]=-4.0;
  lsup[0]=4.0;
  lsup[1]=4.0;
  pres[0]=4;
  pres[1]=4;
  int sndelit=50;
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }


  strcpy(archivo,argv[1]);


  Fonseca mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,1,sndelit,pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}

