#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"


class Viennet2:public MicroAG{
public:  
  Viennet2(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
};
void Viennet2::evalua(int *cromosoma,double *aptitud){
  double x=decodifica(0,cromosoma);
  double y=decodifica(1,cromosoma);
  aptitud[0]=(pow((x-2),2))/2+(pow((y+1),2))/13+3;
  aptitud[1]=(pow((x+y-3),2))/36+(pow((-x+y+2),2))/8-17;
  aptitud[2]=pow((x+2*y-1),2)/175+pow((2*y-x),2)/17-13;
}
void Viennet2::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    /*
    
      double x=decodifica(0,ind[i].genotipo);
      double y=decodifica(1,ind[i].genotipo);
      archivo<<x;
      archivo<<"\t";
      archivo<<y;
      archivo<<"\n";
    */
  }
}

int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int GMax=1000;
  int M=4;
  int nTope=5;
  int nGenes=2;
  int nObjs=3;
  int base=2;
  int subDivs=10;
  double Pc=0.3,Pm=(double)1.0/34.0;
  double *linf=new(double[2]);
  double *lsup=new(double[2]);
  int *pres=new(int[2]);
  linf[0]=-4.0;
  linf[1]=-4.0;
  lsup[0]=4.0;
  lsup[1]=4.0;
  pres[0]=4;
  pres[1]=4;
  int sndelit=50;
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);

  Viennet2 mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,1,sndelit,pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}
