#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"
/*
MOP 2 con el que se probo el NSGA II
Funcion 2 de Fonseca
 */

class Fonseca2:public MicroAG{
public:  
  Fonseca2(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *);
};
void Fonseca2::evalua(int *cromosoma,double *aptitud){
  double x[3],sum1=0,sum2=0;
  x[0]=decodifica(0,cromosoma);
  x[1]=decodifica(1,cromosoma);
  x[2]=decodifica(2,cromosoma);

  for(int i=0;i<3;i++){
    sum1+=pow((x[i]-1/(pow((i+1),(double)1.0/2.0))),2);
    sum2+=pow((x[i]+1/(pow((i+1),(double)1.0/2.0))),2);
  }

  aptitud[0]=1-exp(sum1*-1);
  aptitud[1]=1-exp(sum2*-1); 

}
void Fonseca2::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    /*
    
    double x=decodifica(0,ind[i].genotipo);
    double y=decodifica(1,ind[i].genotipo);
    double z=decodifica(2,ind[i].genotipo);
    archivo<<x;
    archivo<<"\t";
    archivo<<y;
    archivo<<"\t";
    archivo<<z;
    archivo<<"\n";
    */
  }
}

int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int GMax=1000;
  int M=4;
  int nTope=5;
  int nGenes=3;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.7,Pm=(double)1.0/42.0;
  double *linf=new(double[3]);//=0.1;
  double *lsup=new(double[3]);//=1;
  int *pres=new(int[3]);//=4;
  linf[0]=0.0;
  linf[1]=0.0;
  linf[2]=0.0;
  lsup[0]=1.0;
  lsup[1]=1.0;
  lsup[2]=1.0;
  pres[0]=4;
  pres[1]=4;
  pres[2]=4;
  int sndelit=50;
  
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);

  Fonseca2 mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,1,sndelit,pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}
