#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"
/*
MOP 4 con el que se probo el NSGA II
Funcion de Kursawe
 */

class Kursawe:public MicroAG{
public:  
  Kursawe(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
};
void Kursawe::evalua(int *cromosoma,double *aptitud){
  double x[3],sum1=0.0,sum2=0.0;
  x[0]=decodifica(0,cromosoma);
  x[1]=decodifica(1,cromosoma);
  x[2]=decodifica(2,cromosoma);

  for(int i=0;i<3;i++){
    if(i<2)
      sum1+=-10.0*exp((-0.2)*sqrt( pow(x[i],2)+pow(x[i+1],2)));
    sum2+=pow(fabs(x[i]),0.8)+5*sin(pow(x[i],3));
  }
  aptitud[0]=sum1;
  aptitud[1]=sum2;
}
void Kursawe::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";

    /*       
	     double x=decodifica(0,ind[i].genotipo);
	     double y=decodifica(1,ind[i].genotipo);
	     double z=decodifica(2,ind[i].genotipo);
	     archivo<<x; 
	     archivo<<"\t";
	     archivo<<y;
	     archivo<<"\t";
	     archivo<<z;
	     archivo<<"\n";
    */
  }
}

int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];

  int tamPARETO=100;
  int tamMem=50;
  int cualfuncion=21;
  int GMax=3000;
  int M=4;
  int nTope=2;
  int nGenes=3;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.7;
  double Pm=(double)1.0/51.0;
  double *linf=new(double[2]);//=0.1;
  double *lsup=new(double[2]);//=1;
  int *pres=new(int[2]);//=4;
  linf[0]=-5.0;
  linf[1]=-5.0;
  lsup[0]=5.0;
  lsup[1]=5.0;
  pres[0]=6;
  pres[1]=6;
  int sndelit=50;
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);
  //Funcion 21 (MOP 4)
  
 

  Kursawe mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,1,sndelit,pNRem,archivo);
  system("date");
  mag.Alg();//inicia el algoritmo. 
  system("date");
}

